
# class ComparatorGen3 

This class is a singleton; you do not create one as a global, on the stack, or with new.

## Members

---

### ComparatorGen3 & ComparatorGen3::withReferenceVoltage(ReferenceVoltage ref) 

```
ComparatorGen3 & withReferenceVoltage(ReferenceVoltage ref)
```

---

### ComparatorGen3 & ComparatorGen3::withInput(pin_t pin) 

Selects the analog input.

```
ComparatorGen3 & withInput(pin_t pin)
```

#### Parameters
* `pin` The Particle pin (A0 - A5) to use.

---

### ComparatorGen3 & ComparatorGen3::withInterruptMode(InterruptMode mode) 

Sets the interrupt mode.

```
ComparatorGen3 & withInterruptMode(InterruptMode mode)
```

#### Parameters
* `mode` The Particle-style interrupt mode: RISING, FALLING, or CHANGE

---

### ComparatorGen3 & ComparatorGen3::withHysteresis(bool enable) 

Enable 50 mV hysteresis mode. Default is disabled.

```
ComparatorGen3 & withHysteresis(bool enable)
```

---

### ComparatorGen3 & ComparatorGen3::withInterruptPriority(uint8_t priority) 

Set the interrupt priority. Default is NRFX_LPCOMP_CONFIG_IRQ_PRIORITY (6).

```
ComparatorGen3 & withInterruptPriority(uint8_t priority)
```

---

### ComparatorGen3 & ComparatorGen3::withEnableOnInit(bool enable) 

Whether to enable interrupts in init(). Default is true.

```
ComparatorGen3 & withEnableOnInit(bool enable)
```

---

### ComparatorGen3 & ComparatorGen3::withEventCallback(std::function< void(nrf_lpcomp_event_t event)> eventCallback) 

Specify the callback function to call.

```
ComparatorGen3 & withEventCallback(std::function< void(nrf_lpcomp_event_t event)> eventCallback)
```

It must have the prototype:

```cpp
void myCallback(nrf_lpcomp_event_t event)
```

Event will be NRF_LPCOMP_EVENT_UP, NRF_LPCOMP_EVENT_DOWN, NRF_LPCOMP_EVENT_CROSS. If you specify interruptMode CHANGE, you only get CROSS, not an indication of which direction you are crossing!

The callback is an ISR, so you must not allocate memory, lock a mutex, or perform lengthy operations from it. You must not use delay(), the Serial, Particle, or Log classes, among others.

The parameter is a C++11 lambda, so you can specify your callback as a lambda instead of a C function pointer. This allows the callback to be a C++ class member instead of a plain C function.

---

### nrfx_err_t ComparatorGen3::init() 

Initialize the LPCOMP module.

```
nrfx_err_t init()
```

You must call the withXXX() methods before calling init()!

---

### void ComparatorGen3::enable() 

Enable the LPCOMP interrupts.

```
void enable()
```

By default, they are automatically enabled on init() unless you call

---

### void ComparatorGen3::disable() 

Disable the LPCOMP interrupts.

```
void disable()
```

---

### void ComparatorGen3::uninit() 

Disable interrupts and release the LPCOMP resources.

```
void uninit()
```

---

### enum ReferenceVoltage 

```
enum ReferenceVoltage
```

 Values                         | Descriptions                                
--------------------------------|---------------------------------------------
REF_0V4            | 
REF_0V8            | 
REF_1V2            | 
REF_1V7            | 
REF_2V1            | 
REF_2V5            | 
REF_2V9            | 
PIN_A0            | 

Generated by [Moxygen](https://sourcey.com/moxygen)